# Threads⨉: Parallelized `Base` functions

[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://tkf.github.io/ThreadsX.jl/dev)
[![GitHub Actions](https://github.com/tkf/ThreadsX.jl/workflows/Run%20tests/badge.svg)](https://github.com/tkf/ThreadsX.jl/actions?query=workflow%3A%22Run+tests%22)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)

## tl;dr

Add prefix `ThreadsX.` to functions from `Base` to get some speedup,
if supported.  Example:

```julia
julia> using ThreadsX

julia> ThreadsX.sum(gcd(42, i) == 1 for i in 1:10_000)
2857
```

To find out functions supported by ThreadsX.jl, just type
`ThreadsX.` + <kbd>TAB</kbd> in the REPL:

``````julia
julia> ThreadsX.
MergeSort       any             findfirst       map!            reduce
QuickSort       collect         findlast        mapreduce       sort
Set             count           foreach         maximum         sort!
StableQuickSort extrema         issorted        minimum         sum
all             findall         map             prod            unique
``````

## Interoperability

### Rich collection support

The `reduce`-based functions support any collections that implement
[`SplittablesBase.jl`](https://github.com/JuliaFolds/SplittablesBase.jl)
interface including arrays, `Dict`, `Set`, and iterator
transformations.  In particular, these functions support iterator
comprehension:

```julia
julia> ThreadsX.sum(y for x in 1:10 if isodd(x) for y in 1:x^2)
4917
```

For advanced usage, they also support
[`Transducers.eduction`](https://juliafolds.github.io/Transducers.jl/dev/manual/#Transducers.eduction)
constructed with parallelizable transducers.

### OnlineStats.jl

`ThreadsX.reduce` supports an `OnlineStat` from
[OnlineStats.jl](https://github.com/joshday/OnlineStats.jl) as the
first argument as long as it implements the
[merging interface](https://github.com/joshday/OnlineStatsBase.jl#interface):

```julia
julia> using OnlineStats: Mean

julia> ThreadsX.reduce(Mean(), 1:10)
Mean: n=10 | value=5.5
```

## API

ThreadsX.jl is aiming at providing API compatible with `Base`
functions to easily parallelize Julia programs.

All functions that exist directly under `ThreadsX` namespace are
public API and they implement a subset of API provided by `Base`.
Everything inside `ThreadsX.Implementations` is implementation detail.
The public API functions of `ThreadsX` expect that the data structure
and function(s) passed as argument are "thread-friendly" in the sense
that operating on _distinct_ elements in the given container from
multiple tasks in parallel is safe. For example, `ThreadsX.sum(f,
array)` assumes that executing `f(::eltype(array))` and accessing
elements as in `array[i]` from multiple threads is safe.  In
particular, this is the case if `array` is a `Vector` of immutable
objects and `f` is a pure function in the sense it does not mutate any
global objects.  Note that it is not required and _not recommended_ to
use "thread-safe" array that protects accessing `array[i]` by a lock.

In addition to the `Base` API, all functions accept keyword argument
`basesize::Integer` to configure the number of elements processed by
each thread.  A large value is useful for minimizing the overhead of
using multiple threads.  A small value is useful for load balancing
when the time to process single item varies a lot from item to item.
The default value of `basesize` for each function is currently an
implementation detail.

ThreadsX.jl API is deterministic in the sense that the same input
produces the same output, independent of how `julia`'s task scheduler
decide to execute the tasks.  However, note that `basesize` is a part
of the input which may be set based on `Threads.nthreads()`.  To make
the result of the computation independent of `Threads.nthreads()`
value, `basesize` must be specified explicitly.

## Limitations

* Keyword argument `dims` is not supported yet.
* (There are probably more.)

## Implementations

Most of `reduce`-based functions are implemented as thin wrappers of
[`Transducers.jl`](https://github.com/JuliaFolds/Transducers.jl).

Custom collections can support ThreadsX.jl API by implementing
[`SplittablesBase.jl`](https://github.com/JuliaFolds/SplittablesBase.jl)
interface.

module BenchForeachSeqDouble

using BenchmarkTools
using Referenceables
using ThreadsX

@inline function manual_double!(ys)
    @simd ivdep for i in eachindex(ys)
        @inbounds ys[i] *= 2
    end
end

@inline function manual_nested_double!(ys::AbstractMatrix)
    for j in axes(ys, 2)
        @simd ivdep for i in axes(ys, 1)
            @inbounds ys[i, j] *= 2
        end
    end
end

double!(y) = y[] *= 2

suite = BenchmarkGroup()

let s0 = suite["linear"] = BenchmarkGroup()
    ys = randn(2^10)
    s0["man"] = @benchmarkable manual_double!(ys) setup = (ys = copy($ys))
    s1 = s0["tx"] = BenchmarkGroup()
    for simd in [false, true, :ivdep]
        s1[:simd=>simd] = @benchmarkable(
            ThreadsX.Implementations.foreach_linear_seq(
                double!,
                referenceable(ys),
                $(Val(simd)),
            ),
            setup = (ys = copy($ys)),
        )
    end
end

let s0 = suite["cartesian"] = BenchmarkGroup()
    # `size(ys, 1)` seems to be large enough to make this benchmark
    # somewhat stable
    ys = randn(2^8, 2^5)
    s0["man"] = @benchmarkable manual_nested_double!(ys') setup = (ys = copy($ys))
    s1 = s0["tx"] = BenchmarkGroup()
    for simd in [false, true, :ivdep]
        s1[:simd=>simd] = @benchmarkable(
            ThreadsX.Implementations.foreach_cartesian_seq(
                double!,
                referenceable(ys'),
                $(Val(simd)),
            ),
            setup = (ys = copy($ys)),
        )
    end
end

end  # module
BenchForeachSeqDouble.suite

default_basesize(n::Integer) = max(1, cld(n, (8 * Threads.nthreads())))
default_basesize(xs) =
    default_basesize(SplittablesBase.amount(last(extract_transducer(xs))))

default_basesize(_, _, xs) = default_basesize(xs::AbstractArray)

# TODO: handle `Base.Fix2` etc.
# TODO: tune this; it's just copied from `findfirst`
default_basesize(::typeof(ThreadsX.any), _, xs) = 2^15

default_basesize(::typeof(ThreadsX.all), f, xs) =
    default_basesize(ThreadsX.any, f, xs)

default_basesize(::typeof(ThreadsX.findfirst), _, xs) = 2^15

default_basesize(::typeof(ThreadsX.findlast), f, xs) =
    default_basesize(ThreadsX.findfirst, f, xs)

# `@btime wait(Threads.@spawn nothing)` shows ~1 μs overhead of
# spawning a task.  So let's choose the basesize such that basecase
# takes much longer time than this (say 20 μs).

function default_basesize(
    ::typeof(ThreadsX.extrema),
    ::typeof(identity),
    xs::AbstractArray{T},
) where {T<:Integer}
    if isconcretetype(T)
        return 2^20 ÷ sizeof(T)
    end
    return default_basesize(xs)
end

default_basesize(
    ::typeof(ThreadsX.extrema),
    ::typeof(identity),
    ::AbstractArray{<:Union{Float32,Float64}},
) = 8192

default_basesize(
    ::typeof(ThreadsX.extrema),
    ::typeof(identity),
    ::AbstractArray{Float16},  # slower?
) = 2048

module BenchFindfirst

import Random
using BenchmarkTools
using ThreadsX

Random.seed!(1234)

n = 2^20

suite = BenchmarkGroup()

xs0 = rand(n)
for percent in [0, 10, 20, 30, 40, 50]
    xs = copy(xs0)
    xs[max(1, floor(Int, length(xs) * percent / 100))] = -1
    s = suite["$(percent)%"] = BenchmarkGroup()
    s["tx"] = @benchmarkable(ThreadsX.findfirst(==(-1), $xs))
    s["tx-noterm"] = @benchmarkable(ThreadsX.findfirst(==(-1), $xs, stoppable = false))
    s["tx-seq"] = @benchmarkable(ThreadsX.findfirst(==(-1), $xs, basesize = typemax(Int)))
    s["base"] = @benchmarkable(findfirst(==(-1), $xs))
end

end  # module
BenchFindfirst.suite

module TestWithBase

using Base: splat
using Test
using ThreadsX

args_and_kwargs(args...; kwargs...) = args, (; kwargs...)

inc(x) = x + 1

mapi(args...) = map(args...)

raw_testdata = """
collect(1:10)
collect(Float64, 1:10)
collect(x for x in 1:10 if isodd(x))
collect(Float64, (x for x in 1:10 if isodd(x)))
collect(inc(x) for x in 1:10)
collect(Float64, (inc(x) for x in 1:10))
collect(x * y for x in 1:10, y in 11:20)
collect(Float64, (x * y for x in 1:10, y in 11:20))
collect(x * y for x in 1:0, y in 11:20)
collect(Float64, (x * y for x in 1:0, y in 11:20))
map(inc, 1:10)
map(inc, (x for x in 1:10 if isodd(x)))
map(inc, Float64[])
map(inc, ones(3, 3))
map(inc, ones(3, 0))
map(inc, ones(0, 3))
map(*, 1:10, 11:20)
map(*, ones(3, 3), ones(3, 3))
map(*, ones(3, 0), ones(3, 0))
map(*, ones(0, 3), ones(0, 3))
map(splat(*), Iterators.product(1:10, 11:20))
map(splat(*), Iterators.product(1:0, 11:20))
reduce(+, 1:10)
reduce(+, 1:0)
reduce(+, Bool[])
reduce(+, (x^2 for x in 1:10))
reduce(+, (x for x in 1:10 if isodd(x)))
reduce(+, (y for x in 1:10 for y in 1:x))
mapreduce(inc, +, 1:10)
mapreduce(*, +, 1:10, 11:20)
mapreduce(*, +, 1:0, 11:10)
mapreduce(inc, +, (x^2 for x in 1:10))
mapreduce(inc, +, (x for x in 1:10 if isodd(x)))
mapreduce(inc, +, (y for x in 1:10 for y in 1:x))
sum(1:10)
sum(1:0)
sum(x -> x^2, 1:10)
sum(x^2 for x in 1:10)
sum(x for x in 1:10 if isodd(x))
sum(y for x in 1:10 for y in 1:x)
prod(1:10)
prod(1:0)
prod(x -> x + 1, 1:10)
count(isodd.(1:10))
count(isodd, 1:10)
count(Bool[])
count(isodd, 1:0)
maximum(1:10)
maximum(inc, 1:10)
minimum(1:10)
minimum(inc, 1:10)
any(fill(false, 10))
any([fill(false, 10); true])
any([])
all(fill(true, 10))
all([fill(true, 10); false])
all([])
findfirst([fill(false, 10); true])
findfirst(iseven, 1:10)
findfirst(reshape([fill(false, 10); true; true], 3, 4))
findfirst(==(5), reshape(1:12, 3, 4))
findfirst([])
findfirst(identity, [])
findlast([fill(true, 10); false])
findlast(isodd, 1:10)
findlast(reshape([fill(true, 10); false; false], 3, 4))
findlast(isodd, reshape(1:12, 3, 4))
findlast([])
findlast(identity, [])
findall([fill(false, 10); true])
findall(iseven, 1:10)
findall(reshape([fill(false, 10); true; true], 3, 4))
findall(==(5), reshape(1:12, 3, 4))
findall([])
findall(identity, [])
extrema(1:10)
extrema(sin, 1:10)
issorted(0:9)
issorted(0:9; rev=true)
issorted(0:9; by=_ -> 1)
issorted(reverse(0:9))
issorted(reverse(0:9); rev=true)
issorted(reverse(0:9); by=_ -> 1)
issorted([])
issorted([]; rev=true)
issorted([]; by=_ -> 1)
unique([1, 2, 6, 2])
unique(Real[1, 1.0, 2])
unique(x -> x^2, [1, -1, -3, 4, 3])
Set([1, -1, -3, 4, 3])
Set(x^2 for x in [1, -1, -3, 4, 3])
"""

# An array of `(label, (f, args, kwargs))`
testdata = mapreduce(vcat, split(raw_testdata, "\n", keepempty = false)) do x
    @debug "Parsing: $x"
    f, rest = split(x, "(", limit = 2)
    ex = Meta.parse("DUMMY($rest")
    ex.args[1] = args_and_kwargs
    tests = Any[@eval ($x, ($(Symbol(f)), $ex...))]
    if f == "map"
        y = replace(x, r"^map" => "mapi")
        push!(tests, @eval ($y, (mapi, $ex...)))
    end
    return tests
end

@testset "$label" for (label, (f, args, kwargs)) in testdata
    g = getproperty(ThreadsX, nameof(f))
    @testset "default basesize" begin
        @test g(args...; kwargs...) == f(args...; kwargs...)
    end
    @testset for basesize in 1:3
        @test g(args...; kwargs..., basesize = basesize) == f(args...; kwargs...)
    end
end

function test_all_implementations(test, name)
    @testset "Base" begin
        test(getproperty(Base, name))
    end
    @testset "ThreadsX" begin
        f = getproperty(ThreadsX, name)
        @testset "default basesize" begin
            test(f)
        end
        @testset for basesize in 1:3
            test((args...) -> f(args...; basesize = basesize))
        end
    end
end

@testset "foreach(x -> ys[x] = x^2, 1:5)" begin
    test_all_implementations(:foreach) do foreach
        xs = 1:5
        ys = zero(xs)
        foreach(xs) do x
            ys[x] = x^2
        end
        @test ys == xs .^ 2
    end
end

@testset "foreach((i, x) -> ys[i] = x^2, eachindex(ys, xs), xs)" begin
    test_all_implementations(:foreach) do foreach
        xs = 11:15
        ys = zero(xs)
        foreach(eachindex(ys, xs), xs) do i, x
            ys[i] = x^2
        end
        @test ys == xs .^ 2
    end
end

@testset "foreach(..., product(1:2, 1:3))" begin
    test_all_implementations(:foreach) do foreach
        xs = Iterators.product(1:2, 1:3)
        ys = fill((-1, -1), 2, 3)
        foreach(xs) do I
            ys[I...] = I
        end
        @test ys == Tuple.(xs)
    end
end

@testset "foreach(..., product(1:2, 1:3, 1:4))" begin
    test_all_implementations(:foreach) do foreach
        xs = Iterators.product(1:2, 1:3, 1:4)
        ys = fill((-1, -1, -1), 2, 3, 4)
        foreach(xs) do I
            ys[I...] = I
        end
        @test ys == Tuple.(xs)
    end
end

@testset "map!(x -> x^2, ys, xs)" begin
    test_all_implementations(:map!) do map!
        xs = 11:15
        ys = zero(xs)
        map!(x -> x^2, ys, xs)
        @test ys == xs .^ 2
    end
end

@testset "map!(+, ys, xs1, xs2)" begin
    test_all_implementations(:map!) do map!
        xs1 = 1:5
        xs2 = xs1 .* 10
        ys = zero(xs1)
        map!(+, ys, xs1, xs2)
        @test ys == xs1 .+ xs2
    end
end

@testset "map!(+, dest, matrix, matrix')" begin
    test_all_implementations(:map!) do map!
        matrix = reshape(1:9, 3, 3)
        dest = zero(matrix)
        map!(+, dest, matrix, matrix')
        @test dest == matrix .+ matrix'
    end
end

end  # module

maybe_counting_sort!(::Any, ::Any) = false

function maybe_counting_sort!(
    v::AbstractVector{<:Integer},
    order::Union{typeof(Base.Forward),typeof(Base.Reverse)},
)
    (rangelen, minval), ok = preprocess_counting_sort(v)
    (ok && rangelen < div(length(v), 2)) || return false

    # For `Vector{Int64}`, using threads starts to make sense when the
    # length is around 2^17.

    if length(v) >= 2^17
        parallel_sort_int_range!(v, rangelen, minval, order === Base.Reverse)
    else
        sort_int_range!(v, rangelen, minval, order === Base.Reverse ? reverse : identity)
    end

    return true
end

function preprocess_counting_sort(v::AbstractVector{<:Integer})
    minval, maxval = ThreadsX.extrema(v)
    (diff, o1) = Base.sub_with_overflow(maxval, minval)
    (rangelen, o2) = Base.add_with_overflow(diff, oneunit(diff))
    return (rangelen, minval, maxval), (!o1 && !o2)
end

function sort_int_range!(
    x::AbstractVector{<:Integer},
    rangelen,
    minval,
    maybereverse = identity,
)
    offs = 1 - minval

    where = fill(0, rangelen)
    @inbounds for i in eachindex(x)
        where[x[i]+offs] += 1
    end

    idx = firstindex(x)
    @inbounds for i in maybereverse(1:rangelen)
        lastidx = idx + where[i] - 1
        val = i - offs
        for j in idx:lastidx
            x[j] = val
        end
        idx = lastidx + 1
    end

    return x
end

function parallel_sort_int_range!(
    x::AbstractVector{<:Integer},
    rangelen,
    minval,
    rev = false;
    nthreads = Threads.nthreads(),
)

    tasks = Task[]
    chunks = _partition(x, cld(length(x), nthreads))
    @sync for xchunk in chunks
        push!(tasks, @spawn count_ints(xchunk, rangelen, minval))
    end
    where = fetch(tasks[1])
    for t in @view tasks[2:end]
        where .+= fetch(t)
    end
    if rev
        reverse!(where)
    end
    pushfirst!(where, 0)
    acc = 0
    for i in 2:length(where)
        acc = @inbounds where[i] += acc
    end

    indices = _partition(1:rangelen, cld(rangelen, nthreads))
    if rev
        indices = reverse(indices)
    end
    @sync for ichunk in indices
        @spawn scatter_ints!(x, minval, where, ichunk)
    end

    return x
end

function count_ints(xs, rangelen, minval)
    offs = 1 - minval
    where = fill(0, rangelen)
    @inbounds for x in xs
        where[x+offs] += 1
    end
    where
end

function scatter_ints!(x, minval, offsets, indices)
    offs = 1 - minval
    @inbounds for i in indices
        val = i - offs
        for j in offsets[i]:offsets[i+1]-1
            x[firstindex(x)+j] = val
        end
    end
end

function parallel_counting_sort!(
    v::AbstractVector{<:Integer},
    order::Union{typeof(Base.Forward),typeof(Base.Reverse)} = Base.Forward,
)
    (rangelen, minval, maxval), ok = preprocess_counting_sort(v)
    ok || error("Value range too large: min = $(repr(minval)), max = $(repr(maxval))")
    parallel_sort_int_range!(v, rangelen, minval, order === Base.Reverse)
    return v
end

module TestSort

using Random: shuffle
using Test
using ThreadsX

@testset for basesize in 1:8
    @testset for alg in [ThreadsX.MergeSort, ThreadsX.QuickSort, ThreadsX.StableQuickSort]
        @test ThreadsX.sort!(shuffle([1:1000;]); alg = alg, basesize = basesize) == 1:1000
        @test ThreadsX.sort!(
            shuffle([1:1000;]);
            alg = alg,
            basesize = basesize,
            by = inv,
        ) == 1000:-1:1
        @test ThreadsX.sort!([1:1000;]; alg = alg, basesize = basesize) == 1:1000
    end
end

@testset "stable sort" begin
    @testset for alg in [ThreadsX.MergeSort, ThreadsX.StableQuickSort]
        @test ThreadsX.sort(1:45; alg = alg, basesize = 25, by = _ -> 1) == 1:45
        @test ThreadsX.sort(1:1000; alg = alg, basesize = 200, by = _ -> 1) == 1:1000
    end
end

@testset "inplace" begin
    @testset "default" begin
        xs = [1:10;]
        @test ThreadsX.sort!(xs) === xs
        @test issorted(xs)
    end
    @testset for alg in [
        ThreadsX.MergeSort,
        ThreadsX.QuickSort,
        ThreadsX.StableQuickSort,
        MergeSort,
        QuickSort,
    ]
        xs = [1:10;]
        @test ThreadsX.sort!(xs; alg = alg) === xs
        @test issorted(xs)
    end
    @testset for alg in [ThreadsX.MergeSort, ThreadsX.QuickSort, ThreadsX.StableQuickSort]
        xs = [1:10;]
        @test sort!(xs; alg = alg) === xs
        @test issorted(xs)
    end
end

randnans(n) = reinterpret(Float64, [rand(UInt64) | 0x7ff8000000000000 for i in 1:n])

function randn_with_nans(n, p)
    v = randn(n)
    x = findall(rand(n) .< p)
    v[x] = randnans(length(x))
    return v
end

# Taken from "advanced sorting" testset.  This was the only test that
# failed when `fpsort!` was replaced with plain `sort!`.
@testset "NaN" begin
    @testset for n in [0:10; 100; 101; 1000; 1001]
        v = randn_with_nans(n, 0.1)
        @testset for alg in [
                ThreadsX.MergeSort,
                ThreadsX.QuickSort,
                ThreadsX.StableQuickSort,
            ],
            rev in [false, true],
            basesize in 1:8
            # test float sorting with NaNs
            s = ThreadsX.sort(v, alg = alg, rev = rev, basesize = basesize)
            @test issorted(s, rev = rev)
            @test reinterpret(UInt64, v[isnan.(v)]) == reinterpret(UInt64, s[isnan.(s)])
        end
    end
end

@testset "UI" begin
    @test ThreadsX.sort(1:10) == 1:10
    @test ThreadsX.sort(1:10; alg = MergeSort) == 1:10
    @test ThreadsX.sort(1:10; alg = QuickSort) == 1:10
end

end  # module

module BenchSort

using BenchmarkTools
using Random: Random, shuffle
using ThreadsX

Random.seed!(1234)

n = 100_000
datasets = [
    # (label, setup)
    ("I64 (wide)", rand(Int64, n)),
    ("I64 (narrow)", rand(0:9, n)),
    ("F64 (wide)", rand(Float64, n)),
    ("F64 (narrow)", rand(0:0.1:0.9, n)),
    ("sorted", [1:n;]),
    ("reversed", [reverse(1:n);]),
]

suite = BenchmarkGroup()

for (label, xs) in datasets
    s = suite[label] = BenchmarkGroup()
    for algname in [:MergeSort, :QuickSort, :StableQuickSort]
        alg = getproperty(ThreadsX, algname)
        s["ThreadsX.$algname"] =
            @benchmarkable(ThreadsX.sort!(xs; alg = $alg), setup = (xs = copy($xs)))
    end
    s["Base"] = @benchmarkable(sort!(xs), setup = (xs = copy($xs)))
end

end  # module
BenchSort.suite

ThreadsX.copy!(dest::AbstractVector, src::AbstractVector; kwargs...) =
    ThreadsX.copyto!(resize!(dest, length(src)), src; kwargs...)

function ThreadsX.copyto!(
    dest::AbstractArray,
    src::AbstractArray;
    basesize::Integer = default_copyto_basesize(dest, src),
)
    if length(dest) <= basesize
        copyto!(dest, src)
    elseif IndexStyle(dest) isa IndexLinear && IndexStyle(src) isa IndexLinear
        linear_copyto!(dest, src, basesize)
    else
        cartesian_copyto!(dest, src, basesize)
    end
    return dest
end

function linear_copyto!(dest, src, basesize)
    # TODO: support size-compatible but index-incompatible arrays
    @sync for p in _partition(eachindex(dest, src), basesize)
        @spawn if p isa AbstractUnitRange
            copyto!(dest, first(p), src, first(p), length(p))
        else
            copyto!(view(dest, p), view(src, p))
        end
    end
end

function cartesian_copyto!(dest, src, basesize)
    ThreadsX.foreach(eachindex(dest, src); basesize = basesize) do i
        @inbounds dest[i] = src[i]
    end
end

# TODO: Take into account more properties like: sizeof(T), boxed?, union?,
# need conversion?
function default_copyto_basesize(dest::AbstractArray{T}, ::AbstractArray) where {T}
    # 2^19 for 64 bit T
    basesize = 4194304 ÷ elsizeof(T)
    return max(cld(length(dest), Threads.nthreads()), basesize)
end

module TestCopy

using Test
using ThreadsX

@testset "copy vector" begin
    @testset for basesize in [[nothing]; 1:8], n in 0:10, T in [Int, Any]
        ys = Vector{T}(undef, n)
        if basesize === nothing
            @test ThreadsX.copyto!(ys, 1:n) == 1:n
            @test ThreadsX.copy!(ys, 1:n) == 1:n
        else
            @test ThreadsX.copyto!(ys, 1:n; basesize = basesize) == 1:n
            @test ThreadsX.copy!(ys, 1:n; basesize = basesize) == 1:n
        end
    end
end

@testset "copy matrix" begin
    @testset for basesize in [[nothing]; 1:8], n in 0:10, m in 1:5, T in [Int, Any]
        A = Matrix{T}(undef, n, m)
        B = reshape(1:n*m, n, m)
        if basesize === nothing
            @test ThreadsX.copyto!(A, B) == B
        else
            @test ThreadsX.copyto!(A, B; basesize = basesize) == B
        end

        Bt = transpose(reshape(1:n*m, m, n))
        if basesize === nothing
            @test ThreadsX.copyto!(A, Bt) == Bt
        else
            @test ThreadsX.copyto!(A, Bt; basesize = basesize) == Bt
        end
    end
end

end  # module

without_basesize(; basesize = nothing, kw...) = kw

function ThreadsX.reduce(op, itr; kw...)
    xf, reducible = extract_transducer(itr)
    result = foldxt(
        op,
        xf,
        reducible;
        init = Init(op),
        basesize = default_basesize(reducible),
        kw...,
    )
    result === Init(op) && return reduce_empty(op, eltype(itr))
    return result
end

function ThreadsX.mapreduce(f, op, itr; kw...)
    xf, reducible = extract_transducer(itr)
    result = foldxt(
        op,
        opcompose(xf, Map(f)),
        reducible;
        init = Init(op),
        basesize = default_basesize(reducible),
        kw...,
    )
    result === Init(op) && return mapreduce_empty(f, op, eltype(itr))
    return result
end

function ThreadsX.mapreduce(f, op, itr, itrs...; kw...)
    if isempty(itr)
        # `Base` just does `reduce(op, map(f, ...))`:
        return mapreduce(f, op, itr, itrs...; without_basesize(; kw...)...)
    end
    return foldxt(
        op,
        MapSplat(f),
        zip(itr, itrs...);
        basesize = default_basesize(itr),
        kw...,
    )
end

# Maybe refactor the function based on mapreduce into AbstractReducers.jl?

ThreadsX.sum(itr; kw...) = ThreadsX.sum(identity, itr; kw...)
ThreadsX.sum(f, itr; kw...) = ThreadsX.mapreduce(f, add_sum, itr; simd = Val(true), kw...)

ThreadsX.prod(itr; kw...) = ThreadsX.prod(identity, itr; kw...)
ThreadsX.prod(f, itr; kw...) = ThreadsX.mapreduce(f, mul_prod, itr; simd = Val(true), kw...)

ThreadsX.count(itr; kw...) = ThreadsX.count(identity, itr; kw...)
ThreadsX.count(f, itr; kw...) =
    ThreadsX.sum(x -> Int(f(x)::Bool), itr; init = 0, simd = Val(true), kw...)

ThreadsX.maximum(itr; kw...) = ThreadsX.maximum(identity, itr; kw...)
ThreadsX.maximum(f, itr; kw...) = ThreadsX.mapreduce(f, max, itr; simd = Val(true), kw...)

ThreadsX.minimum(itr; kw...) = ThreadsX.minimum(identity, itr; kw...)
ThreadsX.minimum(f, itr; kw...) = ThreadsX.mapreduce(f, min, itr; simd = Val(true), kw...)

asbool(f) = x -> f(x)::Bool

# TODO: `any` and `all` should be done with "unordered" version
ThreadsX.any(itr; kw...) = ThreadsX.any(identity, itr; kw...)
ThreadsX.any(f, itr; kw...) = foldxt(
    right,  # no need to use `|`
    opcompose(Map(asbool(f)), ReduceIf(identity)),
    simd = Val(true),
    basesize = default_basesize(ThreadsX.any, f, itr),
    itr;
    kw...,
    init = false,
)

ThreadsX.all(itr; kw...) = ThreadsX.all(identity, itr; kw...)
ThreadsX.all(f, itr; kw...) = foldxt(
    right,  # no need to use `&`
    opcompose(Map(asbool(f)), ReduceIf(!)),
    itr;
    simd = Val(true),
    basesize = default_basesize(ThreadsX.all, f, itr),
    kw...,
    init = true,
)

ThreadsX.findfirst(itr; kw...) = ThreadsX.findfirst(identity, itr; kw...)
ThreadsX.findfirst(f, array::AbstractArray; kw...) = foldxt(
    right,
    ReduceIf(i -> f(@inbounds array[i])),
    keys(array);
    init = nothing,
    simd = Val(true),
    basesize = default_basesize(ThreadsX.findfirst, f, array),
    kw...,
)

ThreadsX.findlast(itr; kw...) = ThreadsX.findlast(identity, itr; kw...)
function ThreadsX.findlast(f, array::AbstractArray; kw...)
    idx = keys(array)
    return foldxt(
        right,
        opcompose(Map(i -> (@inbounds idx[i])), ReduceIf(i -> f(@inbounds array[i]))),
        lastindex(idx):-1:firstindex(idx);
        init = nothing,
        simd = Val(true),
        basesize = default_basesize(ThreadsX.findlast, f, array),
        kw...,
    )
end

ThreadsX.findall(itr; kw...) = ThreadsX.findall(identity, itr; kw...)
function ThreadsX.findall(f, array::AbstractArray; kw...)
    idxs = tcollect(
        Filter(i -> f(@inbounds array[i])),
        keys(array);
        simd = Val(true),
        kw...,
    )
    isempty(idxs) && return keytype(array)[]
    return idxs
end

_minmax((min0, max0), (min1, max1)) = (min(min0, min1), max(max0, max1))

ThreadsX.extrema(itr; kw...) = ThreadsX.extrema(identity, itr; kw...)
ThreadsX.extrema(f, itr; kw...) = foldxt(
    asmonoid(_minmax),
    Map(x -> (y = f(x); (y, y))),
    itr;
    simd = Val(true),
    basesize = default_basesize(ThreadsX.extrema, f, itr),
    kw...,
)

ThreadsX.issorted(
    itr;
    lt = isless,
    by = identity,
    rev::Union{Bool,Nothing} = nothing,
    order::Base.Ordering = Base.Forward,
    kw...,
) = ThreadsX.issorted(itr, Base.ord(lt, by, rev, order); kw...)

ThreadsX.issorted(itr, order::Base.Ordering; kw...) =
    ThreadsX.all(
        zip(
            view(itr, firstindex(itr):lastindex(itr)-1),
            view(itr, firstindex(itr)+1:lastindex(itr)),
        );
        kw...,
    ) do (x1, x2)
        !Base.lt(order, x2, x1)
    end

struct PushUnique{F} <: Function
    f::F
end
PushUnique(::Type{T}) where {T} = PushUnique{Type{T}}(T)

function (f!::PushUnique)((ys, seen), x)
    fx = f!.f(x)
    return fx in seen ? (ys, seen) : (push!!(ys, x), push!!(seen, fx))
end

# TODO: do this with public API of Transducers or make it public
function Transducers.combine(f!::PushUnique, (ys1, seen1), (ys2, seen2))
    seen3 = setdiff!(seen2, seen1)
    isempty(seen3) && return (ys1, seen1)
    return (append!!(Filter(x -> f!.f(x) in seen3), ys1, ys2), union!!(seen1, seen2))
end
# * Add an option to avoid re-compute `f(x)` in combine?
# * Iterate over `seen3` if `length(seen3) << length(ys2)`?

# Manually create a singleton callable since closure captures the
# types as `DataType` and causes type-instability:
struct InitUnique{X,Y} <: Function end
@inline function (::InitUnique{X,Y})() where {X,Y}
    if isbitstype(Y) || Base.isbitsunion(Y)
        return (X[], Set{Y}())
    else
        return (X[], Empty(Set))
    end
end

ThreadsX.unique(itr; kw...) = ThreadsX.unique(identity, itr; kw...)
function ThreadsX.unique(f::F, itr::AbstractVector{X}; kw...) where {F,X}
    # Using inference as an optimization. The result of this inference
    # does not affect the result:
    Y = Core.Compiler.return_type(f, Tuple{X})
    ys, = foldxt(
        PushUnique(f),
        Map(identity),
        itr;
        basesize = default_basesize(itr),
        kw...,
        init = OnInit(InitUnique{X,Y}()),
    )
    return ys::Vector{X}
end

ThreadsX.Set(itr; kw...) = tcopy(Set, itr; kw...)

Base.@kwdef struct ParallelQuickSortAlg{Alg,SmallSize,BaseSize} <: ParallelSortAlgorithm
    smallsort::Alg = Base.Sort.DEFAULT_UNSTABLE
    smallsize::SmallSize = nothing  # lazily determined
    basesize::BaseSize = 10_000
end
# `basesize` is tuned using `Float64`.  Make it `eltype`-aware?
#
# Note: Small `smallsize` (e.g., 32) is beneficial on random data. However, it
# is slower on sorted data with small number of worker threads.
# TODO: Implement some heuristics for `smallsize`.

function Base.sort!(
    v::AbstractVector,
    lo::Integer,
    hi::Integer,
    a::ParallelQuickSortAlg,
    o::Ordering,
)
    if a.basesize === nothing
        a = @set a.basesize = default_basesize(hi - lo + 1)
    end
    if a.smallsize === nothing
        a = @set a.smallsize = a.basesize
    end
    ys = view(v, lo:hi)
    _quicksort!(
        similar(ys),
        ys,
        a,
        o,
        Vector{Int8}(undef, length(ys)),
        false,  # ys_is_result
        true,   # mutable_xs
    )
    return v
end

function _quicksort!(
    ys,
    xs,
    alg,
    order,
    cs = Vector{Int8}(undef, length(ys)),
    ys_is_result = true,
    mutable_xs = false,
)
    @check length(ys) == length(xs)
    if length(ys) <= max(8, alg.basesize)
        return _quicksort_serial!(ys, xs, alg, order, cs, ys_is_result, mutable_xs)
    end
    pivot = _median(
        order,
        (
            xs[1],
            xs[end÷8],
            xs[end÷4],
            xs[3*(end÷8)],
            xs[end÷2],
            xs[5*(end÷8)],
            xs[3*(end÷4)],
            xs[7*(end÷8)],
            xs[end],
        ),
    )
    chunksize = alg.basesize

    # TODO: Calculate extrema during the first pass if it's possible
    # to use counting sort.
    # TODO: When recursing, fuse copying _from_ `ys` to `xs` with the
    # first pass.

    # Compute sizes of each partition for each chunks.
    xs_chunk_list = _partition(xs, chunksize)
    cs_chunk_list = _partition(cs, chunksize)
    nchunks = cld(length(xs), chunksize)
    nbelows = Vector{Int}(undef, nchunks)
    nequals = Vector{Int}(undef, nchunks)
    naboves = Vector{Int}(undef, nchunks)
    @DBG begin
        VERSION >= v"1.4" &&
            @check length(xs_chunk_list) == length(cs_chunk_list) == nchunks
        fill!(nbelows, -1)
        fill!(nequals, -1)
        fill!(naboves, -1)
    end
    @sync for (nb, ne, na, xs_chunk, cs_chunk) in zip(
        referenceable(nbelows),
        referenceable(nequals),
        referenceable(naboves),
        xs_chunk_list,
        cs_chunk_list,
    )
        @spawn partition_sizes!(nb, ne, na, xs_chunk, cs_chunk, pivot, order)
    end
    @DBG begin
        @check all(>=(0), nbelows)
        @check all(>=(0), nequals)
        @check all(>=(0), naboves)
    end

    below_offsets = nbelows
    equal_offsets = nequals
    above_offsets = naboves
    acc = exclusive_cumsum!(below_offsets)
    acc = exclusive_cumsum!(equal_offsets, acc)
    acc = exclusive_cumsum!(above_offsets, acc)
    @check acc == length(xs)

    @inline function singleton_chunkid(i)
        nb = @inbounds get(below_offsets, i + 1, equal_offsets[1]) - below_offsets[i]
        ne = @inbounds get(equal_offsets, i + 1, above_offsets[1]) - equal_offsets[i]
        na = @inbounds get(above_offsets, i + 1, length(ys)) - above_offsets[i]
        if (nb > 0) + (ne > 0) + (na > 0) == 1
            return 1 * (nb > 0) + 2 * (ne > 0) + 3 * (na > 0)
        else
            return 0
        end
    end

    @sync begin
        for (i, (xs_chunk, cs_chunk)) in enumerate(zip(xs_chunk_list, cs_chunk_list))
            singleton_chunkid(i) > 0 && continue
            @spawn unsafe_quicksort_scatter!(
                ys,
                xs_chunk,
                cs_chunk,
                below_offsets[i],
                equal_offsets[i],
                above_offsets[i],
            )
        end
        for (i, xs_chunk) in enumerate(xs_chunk_list)
            sid = singleton_chunkid(i)
            sid > 0 || continue
            idx = (
                below_offsets[i]+1:get(below_offsets, i + 1, equal_offsets[1]),
                equal_offsets[i]+1:get(equal_offsets, i + 1, above_offsets[1]),
                above_offsets[i]+1:get(above_offsets, i + 1, length(ys)),
            )[sid]
            # There is only one partition. Short-circuit scattering.
            ys_chunk = view(ys, idx)
            copyto!(ys_chunk, xs_chunk)
            # Is it better to multi-thread this?
        end
    end

    partitions = (1:equal_offsets[1], above_offsets[1]+1:length(xs))
    @sync begin
        for idx in partitions
            length(idx) <= alg.smallsize && continue
            ys_new = view(ys, idx)
            xs_new = view(xs, idx)
            cs_new = view(cs, idx)
            @spawn let zs
                if mutable_xs
                    zs = xs_new
                else
                    zs = similar(ys_new)
                end
                _quicksort!(zs, ys_new, alg, order, cs_new, !ys_is_result, true)
            end
        end
        for idx in partitions
            length(idx) <= alg.smallsize || continue
            if ys_is_result
                ys_new = view(ys, idx)
            else
                ys_new = copyto!(view(xs, idx), view(ys, idx))
            end
            sort!(ys_new, alg.smallsort, order)
        end
        if !ys_is_result
            let idx = equal_offsets[1]+1:above_offsets[1]
                copyto!(view(xs, idx), view(ys, idx))
            end
        end
    end

    return ys_is_result ? ys : xs
end

function _quicksort_serial!(
    ys,
    xs,
    alg,
    order,
    cs = Vector{Int8}(undef, length(ys)),
    ys_is_result = true,
    mutable_xs = false,
)
    # @check length(ys) == length(xs)
    if length(ys) <= max(8, alg.smallsize)
        if ys_is_result
            zs = copyto!(ys, xs)
        else
            zs = xs
        end
        return sort!(zs, alg.smallsort, order)
    end
    pivot = _median(
        order,
        (
            xs[1],
            xs[end÷8],
            xs[end÷4],
            xs[3*(end÷8)],
            xs[end÷2],
            xs[5*(end÷8)],
            xs[3*(end÷4)],
            xs[7*(end÷8)],
            xs[end],
        ),
    )

    (nbelows, nequals) = partition_sizes!(xs, cs, pivot, order)
    if nequals == length(xs)
        if ys_is_result
            copyto!(ys, xs)
            return ys
        else
            return xs
        end
    end
    @assert nequals > 0
    below_offset = 0
    equal_offset = nbelows
    above_offset = nbelows + nequals
    unsafe_quicksort_scatter!(ys, xs, cs, below_offset, equal_offset, above_offset)

    below = 1:equal_offset
    above = above_offset+1:length(xs)
    ya = view(ys, above)
    yb = view(ys, below)
    ca = view(cs, above)
    cb = view(cs, below)
    if mutable_xs
        _quicksort_serial!(view(xs, above), ya, alg, order, ca, !ys_is_result, true)
        _quicksort_serial!(view(xs, below), yb, alg, order, cb, !ys_is_result, true)
    else
        let zs = similar(ys)
            _quicksort_serial!(view(zs, above), ya, alg, order, ca, !ys_is_result, true)
            _quicksort_serial!(view(zs, below), yb, alg, order, cb, !ys_is_result, true)
        end
    end
    if !ys_is_result
        let idx = equal_offset+1:above_offset
            copyto!(view(xs, idx), view(ys, idx))
        end
    end

    return ys_is_result ? ys : xs
end

function partition_sizes!(nbelows, nequals, naboves, xs, cs, pivot, order)
    (nb, ne) = partition_sizes!(xs, cs, pivot, order)
    nbelows[] = nb
    nequals[] = ne
    naboves[] = length(xs) - (nb + ne)
    return
end

function partition_sizes!(xs, cs, pivot, order)
    nbelows = 0
    nequals = 0
    @inbounds for i in eachindex(xs, cs)
        x = xs[i]
        b = Base.lt(order, x, pivot)
        a = Base.lt(order, pivot, x)
        cs[i] = ifelse(b, -Int8(1), ifelse(a, Int8(1), Int8(0)))
        nbelows += Int(b)
        nequals += Int(!(a | b))
    end
    return (nbelows, nequals)
end

function unsafe_quicksort_scatter!(
    ys,
    xs_chunk,
    cs_chunk,
    below_offset,
    equal_offset,
    above_offset,
)
    b = below_offset
    e = equal_offset
    a = above_offset
    _foldl((b, a, e), Unroll{4}(eachindex(xs_chunk, cs_chunk))) do (b, a, e), i
        @inbounds x = xs_chunk[i]
        @inbounds c = cs_chunk[i]
        is_equal = c == 0
        is_above = c > 0
        is_below = c < 0
        e += Int(is_equal)
        a += Int(is_above)
        b += Int(is_below)
        @inbounds ys[ifelse(is_equal, e, ifelse(is_above, a, b))] = x
        (b, a, e)
    end
    return
end

function adhoc_partition(xs, n)
    @check firstindex(xs) == 1
    m = cld(length(xs), n)
    return (view(xs, i*n+1:min((i+1)*n, length(xs))) for i in 0:m-1)
end

if VERSION >= v"1.4"
    const _partition = Iterators.partition
else
    const _partition = adhoc_partition
end

@inline _asval(x::Val) = x
@inline _asval(x) = Val(x)

const SIMDValFlag = Union{Val{true}, Val{false}, Val{:ivdep}}
const SIMDFlag = Union{Bool, Symbol, SIMDValFlag}

__verify_simd_flag(simd::SIMDValFlag, _) = simd
__verify_simd_flag(_, simd) =
    throw(ArgumentError("Invalid `simd` option: $(repr(simd))"))

verify_simd_flag(simd) = __verify_simd_flag(_asval(simd), simd)

# TODO: handle Union
function elsizeof(::Type{T}) where {T}
    if Base.allocatedinline(Some{T})
        return sizeof(Some{T})
    else
        return sizeof(Ptr{Any})
    end
end

function _median(order, (a, b, c)::NTuple{3,Any})
    # Sort `(a, b, c)`:
    if Base.lt(order, b, a)
        a, b = b, a
    end
    if Base.lt(order, c, a)
        a, c = c, a
    end
    if Base.lt(order, c, b)
        b, c = c, b
    end
    return b
end

_median(order, (a, b, c, d, e, f, g, h, i)::NTuple{9,Any}) = _median(
    order,
    (_median(order, (a, b, c)), _median(order, (d, e, f)), _median(order, (g, h, i))),
)

function maptasks(f, xs)
    tasks = Task[]
    @sync for x in xs
        push!(tasks, @spawn f(x))
    end
    return map(fetch, tasks)
end

function exclusive_cumsum!(xs, acc = zero(eltype(xs)))
    @inbounds for i in eachindex(xs)
        xs[i], x = acc, xs[i]
        acc += x
    end
    return acc
end

struct Unroll{N,A}
    xs::A
end

Unroll{N}(xs::A) where {N,A} = Unroll{N,A}(xs)

@inline _foldlargs(op, acc) = acc
@inline _foldlargs(op, acc, x, xs...) = _foldlargs(op, op(acc, x), xs...)

@inline function _foldl(op::F, acc, itr::Unroll{N}) where {N,F}
    i = firstindex(itr.xs)
    n = lastindex(itr.xs) - N
    while i <= n
        acc = let i = i
            _foldlargs(acc, ntuple(identity, Val{N}())...) do acc, k
                op(acc, @inbounds itr.xs[i + (k - 1)])
            end
        end
        i += N
    end
    while i <= lastindex(itr.xs)
        acc = op(acc, @inbounds itr.xs[i])
        i += 1
    end
    return acc
end

function define_docstrings()
    docstrings = [:ThreadsX => joinpath(dirname(@__DIR__), "README.md")]
    docsdir = joinpath(@__DIR__, "docs")
    for filename in readdir(docsdir)
        stem, ext = splitext(filename)
        ext == ".md" || continue
        name = Symbol(stem)
        name in names(ThreadsX, all=true) || continue
        push!(docstrings, name => joinpath(docsdir, filename))
    end
    for (name, path) in docstrings
        include_dependency(path)
        doc = read(path, String)
        doc = replace(doc, r"^```julia"m => "```jldoctest $name")
        doc = replace(doc, "<kbd>TAB</kbd>" => "_TAB_")
        @eval ThreadsX $Base.@doc $doc $name
    end
end

baremodule ThreadsX

function collect end
function map end
function mapi end

function mapreduce end
function reduce end

# Functions derived from `reduce`
function sum end
function prod end
function count end
function maximum end
function minimum end

# Functions implemented directly in terms of transducers
function any end
function all end
function findfirst end
function findlast end
function findall end
# function findmax end
# function findmin end
# function argmax end
# function argmin end
function extrema end
function issorted end
function unique end
function Set end

function foreach end
function map! end
function copy! end
function copyto! end

function sort end
function sort! end

module Implementations
import SplittablesBase
using ArgCheck: @argcheck, @check
using BangBang: SingletonVector, append!!, push!!, union!!
using Base:
    HasShape, IteratorSize, Ordering, add_sum, mapreduce_empty, mul_prod, reduce_empty
using ConstructionBase: setproperties
using InitialValues: asmonoid
using MicroCollections: EmptyVector
using Referenceables: referenceable
using Setfield: @set
using Transducers:
    Cat,
    Empty,
    Filter,
    Init,
    Map,
    MapSplat,
    NondeterministicThreading,
    OnInit,
    ReduceIf,
    Transducers,
    extract_transducer,
    foldxl,
    opcompose,
    reduced,
    right,
    tcollect,
    tcopy
using ..ThreadsX

@static if VERSION >= v"1.3-alpha"
    using Base.Threads: @spawn
else
    # Mock `@spawn` using `@async`:
    @eval const $(Symbol("@spawn")) = $(Symbol("@async"))
end

if isdefined(Transducers, :foldxt)
    using Transducers: foldxt
else
    foldxt(rf, xf, xs; kw...) = reduce(rf, xf, xs; kw...)
    foldxt(rf, xs; kw...) = reduce(rf, Map(identity), xs; kw...)
end

include("debug.jl")
include("utils.jl")
include("basesizes.jl")
include("reduce.jl")
include("foreach.jl")
include("map.jl")
include("copy.jl")
include("mergesort.jl")
include("quicksort.jl")
include("countingsort.jl")
end  # module Implementations

const MergeSort = Implementations.ParallelMergeSortAlg()
const QuickSort = Implementations.ParallelQuickSortAlg()
const StableQuickSort =
    Implementations.ParallelQuickSortAlg(smallsort = MergeSort.smallsort)

Implementations.define_docstrings()

end # baremodule ThreadX

module TestAqua

import Aqua
import ThreadsX
using Test

# Default `Aqua.test_all(ThreadsX)` does not work due to ambiguities
# in upstream packages.
Aqua.test_all(ThreadsX; ambiguities = false)

@testset "Method ambiguity" begin
    Aqua.test_ambiguities(ThreadsX)
end

end  # module

module TestThreadsX
using Test

@testset "$file" for file in sort([
    file for file in readdir(@__DIR__) if match(r"^test_.*\.jl$", file) !== nothing
])

    if file == "test_doctest.jl"
        if lowercase(get(ENV, "JULIA_PKGEVAL", "false")) == "true"
            @info "Skipping doctests on PkgEval."
            continue
        elseif VERSION >= v"1.6-"
            @info "Skipping doctests on Julia $VERSION."
            continue
        end
    end

    include(file)
end
end  # module

"""
    @DBG expression_to_run_only_when_debugging
"""
macro DBG(ex)
    quote
        isdebugging() && $(esc(ex))
        nothing
    end
end

isdebugging() = false
enable_debug() = (@eval isdebugging() = true; nothing)
disable_debug() = (@eval isdebugging() = false; nothing)

module BenchForeachSeq

using BenchmarkTools
using ThreadsX.Implementations: foreach_cartesian_seq

const floatsink = Ref(0.0)
@inline consume(x) = floatsink[] = ifelse(x == 0, x, floatsink[])

function foreachc(f::F, xs) where {F}
    foreach_cartesian_seq(f, xs, Val(false))
end

n = 1000
v = ones(n * n)
m = ones(n, n)
suite = BenchmarkGroup()

for (label, _foreach) in [("base", foreach), ("tx", foreachc)]
    s = suite[label] = BenchmarkGroup()
    s["Vector"] = @benchmarkable($_foreach(consume, $v))
    s["Matrix"] = @benchmarkable($_foreach(consume, $m))
    s["Transpose"] = @benchmarkable($_foreach(consume, transpose($m)))
end

end  # module
BenchForeachSeq.suite

using Documenter
using JSON
using ThreadsX

function should_push_preview(event_path = get(ENV, "GITHUB_EVENT_PATH", nothing))
    event_path === nothing && return false
    event = JSON.parsefile(event_path)
    pull_request = get(event, "pull_request", nothing)
    pull_request === nothing && return false
    labels = [x["name"] for x in pull_request["labels"]]
    # https://developer.github.com/v3/activity/events/types/#pullrequestevent
    yes = "push_preview" in labels
    if yes
        @info "Trying to push preview as label `push_preview` is specified." labels
    else
        @info "Not pushing preview as label `push_preview` is not specified." labels
    end
    return yes
end

makedocs(;
    modules=[ThreadsX],
    format=Documenter.HTML(),
    pages=[
        "Home" => "index.md",
    ],
    repo="https://github.com/tkf/ThreadsX.jl/blob/{commit}{path}#L{line}",
    sitename="ThreadsX.jl",
    authors="Takafumi Arakaki <aka.tkf@gmail.com>",
)

deploydocs(;
    repo="github.com/tkf/ThreadsX.jl",
    push_preview = should_push_preview(),
)

module BenchUnique

using BenchmarkTools
using Random: shuffle
using ThreadsX

n = 1_000_000
datasets = [
    # (label, setup)
    ("rand(1:10, $n)", rand(1:10, n)),
    ("rand(1:1000, $n)", rand(1:1000, n)),
]

suite = BenchmarkGroup()

for (label, xs) in datasets
    s = suite[label] = BenchmarkGroup()
    s["tx"] = @benchmarkable(ThreadsX.unique($xs))
    s["base"] = @benchmarkable(unique($xs))
end

end  # module
BenchUnique.suite

module BenchForeach

import ThreadsX
using BenchmarkTools
using Referenceables: referenceable

@inline function f(a, b, c)
    a[] = b + c
end

n = 2000
B = randn(n, n)
C = randn(n, n)
A = similar(B)
suite = BenchmarkGroup()

for (label, _foreach) in [("base", foreach), ("tx", ThreadsX.foreach)]
    s = suite[label] = BenchmarkGroup()
    s["A .= B .+ C"] = @benchmarkable($_foreach(f, referenceable($A), $B, $C))
    s["A .= B .+ B'"] = @benchmarkable($_foreach(f, referenceable($A), $B, $B'))
end

let s = suite["broadcast"] = BenchmarkGroup()
    s["A .= B .+ C"] = @benchmarkable $A .= $B .+ $C
    s["A .= B .+ B'"] = @benchmarkable $A .= $B .+ $B'
end

end  # module
BenchForeach.suite

module TestForeach

using Test
using ThreadsX
using Referenceables

simdflags = [false, true, :ivdep]

function addavg!(c, a, b)
    c[] += (a + b) / 2
end

@testset for simd in [simdflags; Val.(simdflags)], n in [10, 100, 1000]
    basesize = n^2 ÷ 4

    @testset "linear" begin
        A = randn(n, n)
        B = randn(n, n)
        C0 = randn(n, n)
        C1 = copy(C0)
        foreach(addavg!, referenceable(C0), A, B)
        ThreadsX.foreach(addavg!, referenceable(C1), A, B; simd = simd, basesize = basesize)
        @test C0 == C1
    end

    @testset "cartesian" begin
        A = randn(n, n)
        C0 = randn(n, n)
        C1 = copy(C0)
        foreach(addavg!, referenceable(C0), A, A')
        ThreadsX.foreach(
            addavg!,
            referenceable(C1),
            A,
            A';
            simd = simd,
            basesize = basesize,
        )
        @test C0 == C1
    end

    @testset "foreach(f, referenceable(C), product(A, B))" begin
        A = 1:3
        B = 1:2
        C = zeros(3, 2)

        ThreadsX.foreach(referenceable(C), Iterators.product(A, B)) do c, (a, b)
            c[] = a * b
        end

        @test C == A .* reshape(B, 1, :)
    end
end

@testset "argument validation" begin
    @test_throws(
        ArgumentError("Invalid `simd` option: :invalid"),
        ThreadsX.foreach(identity, 1:0; simd = :invalid),
    )
    @test_throws(Exception, ThreadsX.foreach(identity, 1:0; simd = Val(:invalid)),)
end

end  # module

abstract type ParallelSortAlgorithm <: Base.Sort.Algorithm end
(alg::ParallelSortAlgorithm)(; kw...) = setproperties(alg; kw...)

Base.@kwdef struct ParallelMergeSortAlg{Alg,SmallSize,BaseSize} <: ParallelSortAlgorithm
    smallsort::Alg = Base.Sort.DEFAULT_STABLE
    smallsize::SmallSize = nothing  # lazily determined
    basesize::BaseSize = nothing  # lazily determined
end

function Base.sort!(
    v::AbstractVector,
    lo::Integer,
    hi::Integer,
    a::ParallelMergeSortAlg,
    o::Ordering,
)
    if a.basesize === nothing
        a = @set a.basesize = default_basesize(hi - lo + 1)
    end
    if a.smallsize === nothing
        a = @set a.smallsize = a.basesize
    end
    _mergesort!(view(v, lo:hi), a, o)
    return v
end

function mergesorted!(dest, left, right, order, basesize)
    @assert length(dest) == length(left) + length(right)
    if length(left) <= basesize || length(right) <= basesize
        return mergesorted_basecase!(dest, left, right, order)
    end
    if length(left) < length(right)
        c, d = halve(right)
        a, b = halveat(left, searchsortedlast(left, last(c), order) + 1)
    else
        a, b = halve(left)
        c, d = halveat(right, searchsortedfirst(right, first(b), order))
    end
    # length(c) > 0 && length(b) > 0 && @assert Base.lt(order, last(c), first(b))  # stable sort
    ac, bd = halve(dest, length(a) + length(c))
    task = let ac = ac, c = c, a = a
        @spawn mergesorted!(ac, a, c, order, basesize)
    end
    mergesorted!(bd, b, d, order, basesize)
    wait(task)
    return dest
end

@inline function _copyto!(ys, xs)
    for i in eachindex(ys, xs)
        @inbounds ys[i] = xs[i]
    end
    return ys
end

function mergesorted_basecase!(dest::D, left, right, order) where {D}
    # @assert issorted(left; order = order)
    # @assert issorted(right; order = order)
    if isempty(left)
        _copyto!(dest, right)
        return dest
    elseif isempty(right)
        _copyto!(dest, left)
        return dest
    end
    @assert length(dest) == length(left) + length(right)
    i = firstindex(left)
    j = firstindex(right)
    k = firstindex(dest)
    a = @inbounds left[i]
    b = @inbounds right[j]
    while true
        if Base.lt(order, b, a)
            @inbounds dest[k] = b
            j += 1
            k += 1
            if j > lastindex(right)
                _copyto!((@view dest[k:end]), (@view left[i:end]))
                break
            end
            b = @inbounds right[j]
        else
            @inbounds dest[k] = a
            i += 1
            k += 1
            if i > lastindex(left)
                _copyto!((@view dest[k:end]), (@view right[j:end]))
                break
            end
            a = @inbounds left[i]
        end
    end
    # @assert issorted(dest; order = order)
    return dest
end

halve(arr::AbstractArray, mid = length(arr) ÷ 2) = halveat(arr, firstindex(arr) + mid)

function halveat(arr::AbstractArray, i)
    left = @view arr[firstindex(arr):i-1]
    right = @view arr[i:end]
    return (left, right)
end

function _mergesort!(xs, alg, order, tmp = nothing)
    if length(xs) <= alg.smallsize
        sort!(xs, alg.smallsort, order)
        return xs
    end
    left, right = halve(xs)
    left_tmp, right_tmp = halve(tmp === nothing ? similar(xs) : tmp)
    task = @spawn _mergesort!(left, alg, order, left_tmp)
    _mergesort!(right, alg, order, right_tmp)
    wait(task)
    mergesorted!(
        xs,
        _copyto!(left_tmp, left),
        _copyto!(right_tmp, right),
        order,
        alg.basesize,
    )
    return xs
end

ParallelSortAlgorithm(alg::ParallelSortAlgorithm) = alg
ParallelSortAlgorithm(::typeof(MergeSort)) = ParallelMergeSortAlg()
ParallelSortAlgorithm(::typeof(QuickSort)) = ParallelQuickSortAlg()

# bypass `fpsort!`
_sort!(v, a, o) = sort!(v, first(axes(v, 1)), last(axes(v, 1)), a, o)
# TODO: Implement fast `NaN` support as done in `fpsort!`.
# TODO: Use `_sort!` instead of `sort!` for small case (once the `NaN`
# support is implemented).

defalg(v::AbstractArray) = ParallelMergeSortAlg()
defalg(v::AbstractArray{<:Union{Number, Missing}}) = ParallelQuickSortAlg()

"""
    ThreadsX.sort(xs; [smallsort, smallsize, basesize, alg, lt, by, rev, order])

See also [`ThreadsX.sort!`](@ref).
"""
ThreadsX.sort(xs; kwargs...) = ThreadsX.sort!(Base.copymutable(xs); kwargs...)

function ThreadsX.sort!(
    xs;
    smallsort = nothing,
    smallsize = nothing,
    basesize = nothing,
    alg::Base.Sort.Algorithm = defalg(xs),
    lt = isless,
    by = identity,
    rev::Union{Bool,Nothing} = nothing,
    order::Base.Ordering = Base.Forward,
)
    alg = ParallelSortAlgorithm(alg)
    if basesize !== nothing
        alg = @set alg.basesize = basesize
    end
    if smallsort !== nothing
        alg = @set alg.smallsort = smallsort
    end
    if smallsize !== nothing
        alg = @set alg.smallsize = smallsize
    end
    ordr = Base.ord(lt, by, rev, order)
    if maybe_counting_sort!(xs, ordr)
        return xs
    end
    return _sort!(xs, alg, ordr)
end

"""
This benchmark is for demonstrating that `@simd ivdep` can be
beneficial for some cases.  It is constructed such that it is hard for
LLVM to insert run-time memory aliasing check and include a vectorized
version of the loop.
"""
module BenchForeachSeqSumMany

using BenchmarkTools
using ThreadsX

@inline cumsumargs(x, xs...) = (x, _cumsumargs(x, xs...)...)
@inline _cumsumargs(acc, x, xs...) = (acc + x, _cumsumargs(acc + x, xs...)...)
@inline _cumsumargs(acc) = ()

@noinline function manual_sum_many!(vecs::NTuple{N,AbstractArray}) where {N}
    @simd ivdep for i in eachindex(vecs...)
        sums = cumsumargs(map(a -> (@inbounds a[i]), vecs)...)
        @inline update!(j) = @inbounds vecs[j][i] = sums[j]
        ntuple(update!, Val(N))
    end
end

@noinline foreach_sum_many!(vecs::NTuple{N,AbstractArray}, simd) where {N} =
    let nvecs = Val(N)
        @inline function loop_body!(i)
            sums = cumsumargs(map(a -> (@inbounds a[i]), vecs)...)
            @inline update!(j) = @inbounds vecs[j][i] = sums[j]
            ntuple(update!, nvecs)
        end
        ThreadsX.Implementations.foreach_linear_seq(loop_body!, eachindex(vecs...), simd)
    end

suite = BenchmarkGroup()

for nvecs in [8]
    m = 2^10
    vecs = Tuple([randn(m) for _ in 1:nvecs])

    s0 = suite[:nvecs=>nvecs] = BenchmarkGroup()
    s0["man"] = @benchmarkable(manual_sum_many!(vecs), setup = (vecs = map(copy, $vecs)))
    s1 = s0["tx"] = BenchmarkGroup()
    for simd in [false, true, :ivdep]
        s1[:simd=>simd] = @benchmarkable(
            foreach_sum_many!(vecs, $(Val(simd))),
            setup = (vecs = map(copy, $vecs)),
        )
    end
end

end  # module
BenchForeachSeqSumMany.suite

module TestPartition

using Test
using ThreadsX.Implementations: adhoc_partition

@testset for input_length in 1:100, partition_size in 1:100
    @test collect(adhoc_partition(1:input_length, partition_size)) ==
        collect(Iterators.partition(1:input_length, partition_size))
end

end  # module

__map(f, itr; kwargs...) =
    tcollect(Map(f), itr; basesize = default_basesize(itr), kwargs...)
__map(f, itrs...; kwargs...) =
    tcollect(MapSplat(f), zip(itrs...); basesize = default_basesize(itrs[1]), kwargs...)

reshape_as(ys, xs) = reshape_as(ys, xs, IteratorSize(xs))
reshape_as(ys, xs, ::IteratorSize) = ys
reshape_as(ys, xs, ::HasShape) = reshape(ys, size(xs))
reshape_as(::Empty{T}, xs, isize::HasShape) where {T<:AbstractVector} =
    reshape_as(T(undef, length(xs)), xs, isize)

function _map(f, itr, itrs...; kwargs...)
    ys = __map(f, itr, itrs...; kwargs...)
    isempty(ys) && return map(f, itr, itrs...)
    return reshape_as(ys, itr)
end

ThreadsX.map(f, itr, itrs...; kwargs...) = _map(f, itr, itrs...; kwargs...)

function ThreadsX.map(
    f,
    array::AbstractArray{<:Any,N},
    arrays::AbstractArray{<:Any,N}...;
    kwargs...,
) where {N}
    dims = size(array)
    if !all(a -> size(a) == dims, arrays)
        throw(ArgumentError("shape of arrays do not match"))
    end
    output = _map(f, array, arrays...; kwargs...)
    return reshape(output, dims)
end

function ThreadsX.map!(f, dest, array, arrays...; kw...)
    @inline map_body!(y, xs...) = y[] = f(xs...)
    ThreadsX.foreach(map_body!, referenceable(dest), array, arrays...; kw...)
    return dest
end

struct ConvertTo{T} end
(::ConvertTo{T})(x) where {T} = convert(T, x)

ThreadsX.collect(::Type{T}, itr; kwargs...) where {T} = reshape_as(
    tcopy(Map(ConvertTo{T}()), Vector{T}, itr; basesize = default_basesize(itr), kwargs...),
    itr,
)

ThreadsX.collect(itr; kwargs...) =
    reshape_as(tcollect(itr; basesize = default_basesize(itr), kwargs...), itr)


ThreadsX.mapi(f, itr; kwargs...) = reshape_as(
    itr |>
    NondeterministicThreading(; kwargs...) |>
    Map(f) |>
    Map(SingletonVector) |>
    foldxl(append!!; init = EmptyVector()),
    itr,
)

ThreadsX.mapi(f, itr1, itrs...; kwargs...) =
    ThreadsX.mapi(Base.splat(f), zip(itr1, itrs...); kwargs...)

module BenchMapi

using BenchmarkTools
using ThreadsX

collatz(x) =
    if iseven(x)
        x ÷ 2
    else
        3x + 1
    end

function collatz_stopping_time(x)
    n = 0
    while true
        x == 1 && return n
        n += 1
        x = collatz(x)
    end
end

function consume(ns)
    t0 = time_ns()
    d = 0
    while d < ns
        d = Int(time_ns() - t0)
    end
    return d
end

constant(x) = _ -> x

const SUITE = BenchmarkGroup()

let s0 = SUITE["collatz"] = BenchmarkGroup()
    s0["base"] = @benchmarkable map(collatz_stopping_time, 1:1000_000)
    s0["tx"] =
        @benchmarkable ThreadsX.mapi(collatz_stopping_time, 1:1000_000; basesize = 12500)
end

let s0 = SUITE["consume-1ms"] = BenchmarkGroup()
    s0["base"] = @benchmarkable map(consume ∘ constant(1_000_000), 1:20)
    s0["tx"] = @benchmarkable ThreadsX.mapi(consume ∘ constant(1_000_000), 1:20)
end

let s0 = SUITE["consume-100us"] = BenchmarkGroup()
    s0["base"] = @benchmarkable map(consume ∘ constant(100_000), 1:20)
    s0["tx"] = @benchmarkable ThreadsX.mapi(consume ∘ constant(100_000), 1:20)
end

end  # module
BenchMapi.SUITE

ThreadsX.foreach(
    f,
    xs::AbstractArray;
    basesize::Integer = default_basesize(xs),
    simd::SIMDFlag = Val(false),
) = foreach_array(f, IndexStyle(xs), xs, basesize, verify_simd_flag(simd))

function foreach_array(f, ::IndexLinear, xs, basesize, simd::SIMDValFlag)
    @argcheck basesize >= 1
    # TODO: Switch to `Channel`-based implementation when
    # `length(partition(xs, basesize))` is much larger than
    # `nthreads`?
    @sync for p in _partition(xs, basesize)
        @spawn foreach_linear_seq(f, p, simd::SIMDValFlag)
    end
    return
end

function _simdify_if(simd, expr)
    simd === false && return expr
    simd === true && return :(@simd $expr)
    simd === :ivdep && return :(@simd ivdep $expr)
    throw(ArgumentError("simd = $simd"))
end

for simd in [false, true, :ivdep]
    # Note: Using `for x in xs` is sometimes _much_ slower when
    # `@simd` is not used (e.g., `bench_foreach_seq_double.jl`).  This
    # is probably because `@simd` macro forces indexing-based loop.
    body = :(
        for i in eachindex(xs)
            f(@inbounds xs[i])
        end
    )
    @eval @inline foreach_linear_seq(f, xs, ::Val{$(QuoteNode(simd))}) =
        $(_simdify_if(simd, body))
end

function foreach_array(f, style::IndexCartesian, xs, basesize, simd::SIMDValFlag)
    @argcheck basesize >= 1
    if length(xs) == 0
        return
    elseif length(xs) <= basesize
        foreach_cartesian_seq(f, xs, simd)
        return
    end
    left, right = SplittablesBase.halve(xs)
    @sync begin
        @spawn foreach_array(f, style, right, basesize, simd)
        foreach_array(f, style, left, basesize, simd)
    end
    return
end

# Until https://github.com/JuliaLang/julia/pull/35036 is merged and
# released, implement special `foreach` here.
# TODO: Upstream this to Transducers.jl?
@inline foreach_cartesian_seq(
    f::F,
    xs::AbstractArray,
    simd::SIMDValFlag,
    idx::CartesianIndex = CartesianIndex(),
) where {F} = foreach_cartesian_seq(
    f,
    xs,
    simd,
    idx,
    CartesianIndex(1, idx), # "dummy index" used to capture the last loop
)
# Not using default argument for "dummy index" here to make sure
# @inline works.

@inline function foreach_cartesian_seq(
    f::F,
    xs::AbstractArray{<:Any,N},
    simd::SIMDValFlag,
    idx::CartesianIndex{M},
    ::CartesianIndex,
) where {F,N,M}
    for i in axes(xs, N - M)
        foreach_cartesian_seq(f, xs, simd, CartesianIndex(i, idx))
    end
end

for simd in [false, true, :ivdep]
    body = :(
        for i in axes(xs, 1)
            f(@inbounds xs[CartesianIndex(i, idx)])
        end
    )
    @eval @inline foreach_cartesian_seq(
        f::F,
        xs::AbstractArray{<:Any,N},
        ::Val{$(QuoteNode(simd))},
        idx::CartesianIndex{M},
        ::CartesianIndex{N},  # the "dummy index"
    ) where {F,N,M} = $(_simdify_if(simd, body))
end

function ThreadsX.foreach(
    f,
    array::AbstractArray{<:Any,N},
    arrays::AbstractArray{<:Any,N}...;
    kw...,
) where {N}
    @inline foreach_body!(i) =
        f((@inbounds array[i]), map(x -> (@inbounds x[i]), arrays)...)
    ThreadsX.foreach(foreach_body!, eachindex(array, arrays...); kw...)
end

#=
ThreadsX.foreach(f, array::AbstractArray, arrays::AbstractArray; kw...) =
    ThreadsX.foreach(f, map(vec, tuple(array, arrays...))...; kw...)
=#

@inline return_nothing(_...) = nothing

ThreadsX.foreach(f::F, itr; kw...) where {F} = foldxt(
    return_nothing,
    Map(f),
    itr;
    init = nothing,
    basesize = default_basesize(itr),
    kw...,
)

ThreadsX.foreach(f::F, itr, itrs...; kw...) where {F} = foldxt(
    return_nothing,
    MapSplat(f),
    zip(itr, itrs...);
    init = nothing,
    basesize = default_basesize(itr),
    kw...,
)

    ThreadsX.sort!(xs; [smallsort, smallsize, basesize, alg, lt, by, rev, order])

Sort a vector `xs` in parallel.

# Examples

```julia
julia> using ThreadsX

julia> ThreadsX.sort!([9, 5, 2, 0, 1])
5-element Array{Int64,1}:
 0
 1
 2
 5
 9

julia> ThreadsX.sort!([0:5;]; alg = ThreadsX.StableQuickSort, by = _ -> 1)
6-element Array{Int64,1}:
 0
 1
 2
 3
 4
 5
```

It is also possible to use `Base.sort!` directly by specifying `alg`
to be one of the parallel sort algorithms provided by ThreadsX:

```julia
julia> sort!([9, 5, 2, 0, 1]; alg = ThreadsX.MergeSort)
5-element Array{Int64,1}:
 0
 1
 2
 5
 9
```

This entry point may be slower than `ThreadsX.sort!` if the input is a
very large array of integers with small range.  In this case,
`ThreadsX.sort!` uses parallel counting sort whereas `sort!` uses
sequential counting sort.

# Keyword Arguments
- `alg :: Base.Sort.Algorithm`: `ThreadsX.MergeSort`, `ThreadsX.QuickSort`,
  `ThreadsX.StableQuickSort` etc. `Base.MergeSort` and `Base.QuickSort` can
  be used as aliases of `ThreadsX.MergeSort` and `ThreadsX.QuickSort`.
- `smallsort :: Union{Nothing,Base.Sort.Algorithm}`:  The algorithm to use
  for sorting small chunk of the input array.
- `smallsize :: Union{Nothing,Integer}`: Size of array under which `smallsort`
  algorithm is used.  `nothing` (default) means to use `basesize`.
- `basesize :: Union{Nothing,Integer}`.  Granularity of parallelization.
  `nothing` (default) means to choose the default size.
- For keyword arguments, see `Base.sort!`.

    ThreadsX.MergeSort

Parallel merge sort algorithm.

See also [`ThreadsX.QuickSort`](@ref).

# Examples

`ThreadsX.MergeSort` is a `Base.Sort.Algorithm`, just like
`Base.MergeSort`.  It has a few properties for configuring the
algorithm.

```julia
julia> using ThreadsX

julia> ThreadsX.MergeSort isa Base.Sort.Algorithm
true

julia> ThreadsX.MergeSort.smallsort === Base.Sort.DEFAULT_STABLE
true
```

The properties can be "set" by calling the algorithm object itself.  A
new algorithm object with new properties given by the keyword
arguments is returned:

```julia
julia> alg = ThreadsX.MergeSort(smallsort = QuickSort) :: Base.Sort.Algorithm;

julia> alg.smallsort == QuickSort
true

julia> alg2 = alg(basesize = 64, smallsort = InsertionSort);

julia> alg2.basesize
64

julia> alg2.smallsort === InsertionSort
true
```

# Properties
- `smallsort :: Base.Sort.Algorithm`: Default to `Base.Sort.DEFAULT_STABLE`.
- `smallsize :: Union{Nothing,Integer}`: Size of array under which `smallsort`
  algorithm is used.  `nothing` (default) means to use `basesize`.
- `basesize :: Union{Nothing,Integer}`.  Base case size of parallel merge.
  `nothing` (default) means to choose the default size.

    ThreadsX.map!(f, dest, inputs...; basesize, simd)

Parallelized `map!`.  See also [`foreach`](@ref).

# Limitations

Note that the behavior is undefined when using `dest` whose distinct
indices refer to the same memory location.  In particular:

* `SubArray` with overlapping indices. For example, `view(zeros(2),
  [1, 1, 2, 2])` is unsupported but `view(zeros(10), [1, 5, 4, 7])` is
  safe to use.
* `BitArray` (currently unsupported)

    ThreadsX.mapi(f, iterators...; basesize, ntasks)

Parallelized `map(f, iterators...)` that works with purely sequential
`iterators`.

Note that calls to `iterate` on `iterators` are *not* parallelized.
Only `f` may be called in parallel.  See also
`Transducers.NondeterministicThreading` for more information.

!!! note
    Currently, the default `basesize` is 1.  However, it may be
    changed in the future (e.g. it may be automatically tuned at
    run-time).

# Keyword Arguments
- `basesize::Integer`: The number of input elements to be accumulated
  in a buffer before sent to a task.
- `ntasks::Integer`: The number of tasks `@spawn`ed.  The default
  value is `Threads.nthreads()`.  A number larger than
  `Threads.nthreads()` may be useful if the inner reducing function
  contains I/O and does not consume too much resource (e.g., memory).

    ThreadsX.QuickSort
    ThreadsX.StableQuickSort

Parallel quick sort algorithms.

See also [`ThreadsX.MergeSort`](@ref).

# Properties
- `smallsort :: Base.Sort.Algorithm`: Default to `Base.Sort.DEFAULT_UNSTABLE`.
- `smallsize :: Union{Nothing,Integer}`: Size of array under which `smallsort`
  algorithm is used.  `nothing` (default) means to use `basesize`.
- `basesize :: Union{Nothing,Integer}`.  Granularity of parallelization.
  `nothing` (default) means to choose the default size.

    ThreadsX.foreach(f, collections...; basesize, simd)

A parallel version of

``````julia
for args in zip(collections...)
    f(args...)
end
``````

`ThreadsX.foreach` uses linear and Cartesian indexing of `arrays`
appropriately.  However, it is likely very slow for sparse arrays.

Although `ThreadsX.foreach` can be nested, it is highly recommended to
use `CartesianIndices` or `Iterators.product` whenever applicable so
that `ThreadsX.foreach` can load-balance across multiple levels of
loops.  Otherwise (when nesting `ThreadsX.foreach`) it is important to
set `basesize` for outer loops to small values (e.g., `basesize = 1`).

# Keyword Arguments
- `basesize`: The size of base case.
- `simd`: `false`, `true`, `:ivdep`, or `Val` of one of them.  If
  `true`/`:ivdep`, the inner-most loop of each base case is annotated
  by `@simd`/`@simd ivdep`.  This does not occur if `false` (default).

# Examples

```julia
julia> using ThreadsX

julia> xs = 1:10; ys = similar(xs);

julia> ThreadsX.foreach(eachindex(ys, xs)) do I
           @inbounds ys[I] = xs[I]
       end
```

As `foreach` can only be used for side-effects, it is likely that it
has to be used with `eachindex`.

To avoid cumbersome indexing, a powerful pattern is to use
[Referenceables.jl](https://github.com/tkf/Referenceables.jl) with
`foreach`:

```julia
julia> using Referenceables  # exports `referenceable`

julia> ThreadsX.foreach(referenceable(ys), xs) do y, x
           y[] = x
       end
```

Note that `y[]` does not have to be marked by `@inbounds` as it is
ensured to be the reference to the valid location in the array.

Above function can also be written using [`map!`](@ref).  `foreach` is
useful when, e.g., there are multiple outputs:

```julia
julia> A = randn(10, 10); sums = similar(A); muls = similar(A);

julia> ThreadsX.foreach(referenceable(sums), referenceable(muls), A, A') do s, m, x, y
           s[] = x + y
           m[] = x * y
       end
```

Above code _fuses_ the computation of `sums .= A .+ A'` and
`muls .= A .* A'` and runs it in parallel.

`foreach` can also be used when the array is both input and output:

```julia
julia> ThreadsX.foreach(referenceable(A)) do x
           x[] *= 2
       end
```

Nested loops can be written using `Iterators.product`:

```julia
julia> A = 1:3
       B = 1:2
       C = zeros(3, 2);

julia> ThreadsX.foreach(referenceable(C), Iterators.product(A, B)) do c, (a, b)
           c[] = a * b
       end
       @assert C == A .* reshape(B, 1, :)
```

This is equivalent to the following sequential code

```julia
julia> for j in eachindex(B), i in eachindex(A)
           @inbounds C[i, j] = A[i] * B[j]
       end
       @assert C == A .* reshape(B, 1, :)
```

This loop can be expressed also with explicit indexing (which is
closer to the sequential code):

```julia
julia> ThreadsX.foreach(Iterators.product(eachindex(A), eachindex(B))) do (i, j)
           @inbounds C[i, j] = A[i] * B[j]
       end
       @assert C == A .* reshape(B, 1, :)

julia> ThreadsX.foreach(CartesianIndices(C)) do I
           @inbounds C[I] = A[I[1]] * B[I[2]]
       end
       @assert C == A .* reshape(B, 1, :)
```

Note the difference in the ordering in the syntax; i.e., `for j in
eachindex(B), i in eachindex(A)` and `Iterators.product(eachindex(A),
eachindex(B))`.  These are equivalent in the sense `eachindex(A)` is
the inner most loop in both cases.
